// *.rtf -> *.tad converter

#ifndef DEFINE_H_ENVIRONMENT
#define DEFINE_H_ENVIRONMENT

using namespace std;

#include <map>
#include <string>

// vector<Environment>

union type_word {
  unsigned short uw;
  short w;
  struct {
    unsigned char hb; 
    unsigned char lb;
  } bytes;
};

union type_dword {
  unsigned long ul;
  struct {
    unsigned char b1;
    unsigned char b2;
    unsigned char b3;
    unsigned char b4;
  } bytes;
};

// ------------------

struct Font {
  int charset;
  type_word font_type; // gothic,roman,nil...
  //int pitch; // fixed,variable...
  //string fname; // font name
  
  Font();
  //~Font();
};

// ------------------

struct Environment {
  type_word font_attr;
  type_word font_size;
  int nfont;
  type_dword colorval;
  unsigned char alignment;
  unsigned char pat_deco[256];
  bool is_deco[256];
  unsigned char pat_soeji;
  bool is_soeji;
  type_word ind_left,ind_first,ind_right;
  int unicode_ignore;
  
  Environment();
  Environment(const Environment& source);
  //~Environment();
  
  
  // ȉA݂''ێp
  static Environment* current();
  static void outputCurrentEnvironment();
protected:
  static Environment* _instance;
};

#endif // DEFINE_H_ENVIRONMENT
